#!/usr/bin/perl

#This program converts WWWBoard to AnyBoard
# see http://netbula.com/anyboard/abformat.html

$wwwboard_dir = "/home2/anygroup/www/wwwboard/messages"; #directory for wwwboard messages
$ABDir = "/home2/anygroup/www/testf"; #anyboard forum directory
$w3b_ext ="html"; #file extension used by the wwwboard

print "Content-type: text/plain\n\n" if $ENV{SCRIPT_NAME};

print "\nConverting Messages in $wwwboard_dir....\n";

unlink "$ABDir/.msglist"; #let's delete the old index file

%mons =
  ('Jan',1,'Feb',2,'Mar',3,'Apr',4,'May',5,'Jun',6,
  'Jul',7,'Aug',8,'Sep',9,'Oct',10,'Nov',11,'Dec',12);
%days_cnt =
  (1,0,2,31,3,59,4,90,5,120,6,151,7,181,
  8,212,9,243,10,273,11,304,12,334);


@mfs = qw(aK jE fI wW hC mM size pQ xE email eZz to 
          mood tP rhost mtime scat track vers);
@mfs2 = qw(rlink_title img aliases body hack modifier);

opendir (MESSAGES,$wwwboard_dir) or die "Can't open $wwwboard_dir:$!";
@messages = readdir (MESSAGES);
closedir (MESSAGES);

%proced=();

foreach $message (@messages) {
	my $mno = $message;
	$mno =~ s/\..*$//;
	push @mnos, $mno;
}
for(sort {$a <=> $b} @mnos) {
	next if $proced{$_};
	convert_msg($_,0);
}
print "\nFinished conversion: now login your AnyBoard forum and regen the board\n";

#The function below takes a hash which contains the message fields

sub write_ab_msg{
    my %msg = @_;
    return if not $msg{fI}; #error, missing sequence number
    return if not $msg{aK};  #error, missing top sequence number
    open INDEX, ">>$ABDir/.msglist"; #append to index
    for(@mfs) {
	$msg{$_} =~ s/(\t|\n)/ /g; #make sure we don't have tabs in original data
    }
    print INDEX join("\t", @msg{@mfs}), "\n";
    close INDEX;

    my $df= "$ABDir/postdata/".$msg{fI}.".dat";
    open MSGDAT, ">$df" or die "Can't open file $df:$!";
    print MSGDAT "AB8DF\n";
    my $Bound="WWWCONV_SAGGSAGSAHAOSOSIQ".time().rand(); #just some random string
    $Bound =~ s/\.//g;
    print MSGDAT 
    "Content-type: multipart/form-data; boundary=$Bound\n",
    "Content-disposition: form-data; name=message_data$msg{fI}\n\n";
    for(@mfs, @mfs2) {
	print MSGDAT "--$Bound\n";
	print MSGDAT "Content-disposition: form-data; name=$_\n",
                   "Content-type: text/plain\n\n";
      print MSGDAT $msg{$_}, "\n";
    }
    print MSGDAT "--$Bound--\n";
    close MSGDAT;
    print "wrote message $msg{fI}\n";
}

### the function above can be used for other converters

sub convert_msg{
        my ($msg, $top) = @_;
        $proced{$msg} = 1;
	open (FILE, "$wwwboard_dir/$msg.$w3b_ext") or return;
	my @file = <FILE>;
	close (FILE);
	my $title = "";
	my $poster = "";
	my $email = "";
	my $date = "";
	my $body = "";
	my $pno = 0;
	my @followups;
	my $textarea = 0;
        my $see_author=0;
	foreach $line (@file) {
		if ($textarea == 0) {
			if ($line =~ /<title>(.*)<\/title>/i) {
				$title = $1;
			}
			elsif
			  (($line =~
			  /Posted by <a href="mailto:(.*)">(.*)<\/a> \(.*\)/i)
			  || ($line =~
			  /Posted by <a href="mailto:(.*)">(.*)<\/a>/i)) {
				$email = $1;
				$poster = $2;
				$see_author=1;
			}
			elsif
			  (($line =~ /Posted by (.*) \(.*\)/i)
			  || ($line =~ /Posted by (.*)/i)) {
				$poster = $1;
				$date = $2;
				$see_author=1;
			}
			if($see_author==1 && $line =~ /on (.*):<p>/i) {
				$date = $1;
				$textarea = 1;
				$see_author =2;
                        }
			next;
		}
		elsif ($textarea == 1) {
			if ($line =~ /In Reply to: <a\s+href="(\d+).$w3b_ext">/i) {
				$pno = $1;
				if($top ==0 && $pno){
					print "trying to do non-top $msg\n";
					return;
				}
			}
			elsif ($line =~ /<a name="followups">/i) {
				$textarea = 2;
			}
			else {
				$body = $body.$line;
			}
			next;
		}
		elsif ($textarea == 2) {
			if ($line =~ /<a\s+href="(\d+).$w3b_ext">/i) {
				push (@followups,$1);
			}
			elsif ($line =~ /<a name="postfp">/i) {
				last;
			}
			next;
		}
	}
        if($top==0 && not $pno){
		$top = $msg;
        }
	return unless ($title);

	if ($date =~ /(\w*) (\d*), (\d*) at (\d*):(\d*):(\d*)/) {
		$mon = $1;
		$mday = int($2);
		$year = int($3);
		$hour = int($4);
		$min = int($5);
		$sec = int($6);
		if ($year > 19000) { $year -= 17100; }
		$year -= 1900;
		$mon = substr($mon,0,3);
		$mon = int($mons{$mon});
		$mdays = (($year-69)*365)+(int(($year-69)/4));
		$mdays += $days_cnt{$mon};
		if ((int(($year-68)/4) eq (($year-68)/4)) && ($mon>2)) { $mdays++; }
		$mdays += $mday;
		$mdays -= 366;
		$date = ($mdays*86400)+18000;
		$dsthour = (localtime($date))[2];
		if ($dsthour>0) { $date-=3600; }
		$date += ($hour*3600);
		$date += ($min*60);
		$date += $sec;
      }
      write_ab_msg(
		aK=>$top, jE=>$pno,
       		 fI=>$msg, wW=>$title,
       		 hC=>$poster, email=>$email,
			mM=>$date, body=>$body, size=>length($body)
     );
     return if $pno;
     print "Converting followups: ", join(" ", @followups),"\n" if @followups;
     for(@followups) {
	#recurse to followups
	convert_msg($_, $top);
     }
}
